/*-------------------------------------------------------------------
[SCRIPT] Service Broker Sample - Triggers in source database   
[DATABASE] 
[DESCRIPTION] 
[MAJ PAR] DATAFLY - Arian Papillon
[DATEMAJ] SQL Saturday - 05/09/2015  
-------------------------------------------------------------------*/
USE SBSource
GO
CREATE TRIGGER TR_person_update ON person
    FOR UPDATE
AS
    DECLARE @Msg XML;
    SET @Msg = ( SELECT 'dbo' AS '@TableSchema'
                      , 'person' AS '@TableName'
                      , 'update' AS '@Action'
                      , 'BusinessEntityID' AS '@KeyCol'
                      , ( SELECT    COLUMN_NAME
                                  , DATA_TYPE
                                  , CASE IS_NULLABLE
                                      WHEN 'YES' THEN 'true'
                                      ELSE 'false'
                                    END AS is_nullable
                                  , CHARACTER_MAXIMUM_LENGTH AS Charlen
                          FROM      INFORMATION_SCHEMA.COLUMNS [column]
                          WHERE     TABLE_NAME = 'person'
                        FOR
                          XML AUTO
                            , ROOT('TableStructure')
                            , TYPE
                        )
                      , ( SELECT    *
                          FROM      inserted Row
                        FOR
                          XML AUTO
                            , BINARY BASE64
                            , ROOT('TableData')
                            , TYPE
                        )
               FOR
                 XML PATH('DataModification')
               ); 
    DECLARE @IDConversation UNIQUEIDENTIFIER;
    BEGIN DIALOG CONVERSATION @IDConversation
FROM SERVICE [DataModification_Service] TO SERVICE
        'DataSynchro_Service'
ON CONTRACT [DataModification_Contract]
WITH ENCRYPTION = OFF;
    SEND ON CONVERSATION @IDConversation MESSAGE TYPE [DataModification_MessageType] (@Msg);
    SELECT  @Msg;
GO

CREATE TRIGGER TR_person_insert ON person
    FOR INSERT
AS
    DECLARE @Msg XML;
    SET @Msg = ( SELECT 'dbo' AS '@TableSchema'
                      , 'person' AS '@TableName'
                      , 'insert' AS '@Action'
                      , 'BusinessEntityID' AS '@KeyCol'
                      , ( SELECT    COLUMN_NAME
                                  , DATA_TYPE
                                  , CASE IS_NULLABLE
                                      WHEN 'YES' THEN 'true'
                                      ELSE 'false'
                                    END AS is_nullable
                                  , CHARACTER_MAXIMUM_LENGTH AS Charlen
                          FROM      INFORMATION_SCHEMA.COLUMNS [column]
                          WHERE     TABLE_NAME = 'person'
                        FOR
                          XML AUTO
                            , ROOT('TableStructure')
                            , TYPE
                        )
                      , ( SELECT    *
                          FROM      inserted Row
                        FOR
                          XML AUTO
                            , BINARY BASE64
                            , ROOT('TableData')
                            , TYPE
                        )
               FOR
                 XML PATH('DataModification')
               ); 
    DECLARE @IDConversation UNIQUEIDENTIFIER;
    BEGIN DIALOG CONVERSATION @IDConversation
FROM SERVICE [DataModification_Service] TO SERVICE
        'DataSynchro_Service'
ON CONTRACT [DataModification_Contract]
WITH ENCRYPTION = OFF;
    SEND ON CONVERSATION @IDConversation MESSAGE TYPE [DataModification_MessageType] (@Msg);
    SELECT  @Msg;
GO

CREATE TRIGGER TR_person_delete ON person
    FOR DELETE
AS
    DECLARE @Msg XML;
    SET @Msg = ( SELECT 'dbo' AS '@TableSchema'
                      , 'person' AS '@TableName'
                      , 'delete' AS '@Action'
                      , 'BusinessEntityID' AS '@KeyCol'
                      , ( SELECT    COLUMN_NAME
                                  , DATA_TYPE
                                  , CASE IS_NULLABLE
                                      WHEN 'YES' THEN 'true'
                                      ELSE 'false'
                                    END AS is_nullable
                                  , CHARACTER_MAXIMUM_LENGTH AS Charlen
                          FROM      INFORMATION_SCHEMA.COLUMNS [column]
                          WHERE     TABLE_NAME = 'person'
                        FOR
                          XML AUTO
                            , ROOT('TableStructure')
                            , TYPE
                        )
                      , ( SELECT    *
                          FROM      deleted Row
                        FOR
                          XML AUTO
                            , BINARY BASE64
                            , ROOT('TableData')
                            , TYPE
                        )
               FOR
                 XML PATH('DataModification')
               ); 
    DECLARE @IDConversation UNIQUEIDENTIFIER;
    BEGIN DIALOG CONVERSATION @IDConversation
FROM SERVICE [DataModification_Service] TO SERVICE
        'DataSynchro_Service'
ON CONTRACT [DataModification_Contract]
WITH ENCRYPTION = OFF;
    SEND ON CONVERSATION @IDConversation MESSAGE TYPE [DataModification_MessageType] (@Msg);
    SELECT  @Msg;
GO