/*-------------------------------------------------------------------
[SCRIPT] Service Broker Sample - Activation   
[DATABASE] 
[DESCRIPTION] 
[MAJ PAR] DATAFLY - Arian Papillon
[DATEMAJ] SQL Saturday - 05/09/2015  
-------------------------------------------------------------------*/
USE SBDest;
GO
CREATE PROCEDURE Broker_Receive_DataModification
AS
    BEGIN
        SET NOCOUNT ON;   -- dbut de procedure

        DECLARE @conversation UNIQUEIDENTIFIER;
        DECLARE @msg XML;
        DECLARE @msgType NVARCHAR(256);
        DECLARE @BusinessEntityID INT;
        RECEIVE TOP(1) 
		@conversation = conversation_handle,
	    @msgType = message_type_name, 
		@msg = message_body
    FROM DataSynchro_Queue;

        IF ( @@ROWCOUNT = 0 )
            RETURN;

        IF ( @msgType = 'DataModification_MessageType' )  --@msg is not null --
            BEGIN
			-- traitement du message
                DECLARE @XML_NATURE NVARCHAR(30)
                  , @TABLE_SCHEMA sysname
                  , @TABLE_NAME sysname
                  , @SQL_ACTION NVARCHAR(30)
                  , @KEY_COLUMN sysname
                  , @ColumnList NVARCHAR(MAX) = ''
                  , @SQLCmd NVARCHAR(MAX);
			-- extraction de l'action
                SELECT  @XML_NATURE = Txml1.XdataHead.value('fn:local-name(.)', 'NVARCHAR(128)')
                      , @TABLE_SCHEMA = Txml1.XdataHead.value('@TableSchema', 'NVARCHAR(128)')
                      , @TABLE_NAME = Txml1.XdataHead.value('@TableName', 'NVARCHAR(128)')
                      , @SQL_ACTION = Txml1.XdataHead.value('@Action', 'NVARCHAR(128)')
                      , @KEY_COLUMN = Txml1.XdataHead.value('@KeyCol', 'NVARCHAR(128)')
                FROM    @Msg.nodes('./*') AS Txml1 ( XdataHead );

			-- structure de la table
                IF OBJECT_ID('tempdb..#XMLColumns') IS NOT NULL
                    BEGIN
                        DROP TABLE #XMLColumns;
                    END;
                SELECT  x.value('@COLUMN_NAME', 'sysname') AS column_name
                      , x.value('@DATA_TYPE', 'sysname') AS data_type
                      , x.value('@is_nullable', 'VARCHAR(20)') AS is_nullable
                      , x.value('@Charlen', 'VARCHAR(20)') AS Charlen
                INTO    #XMLColumns
                FROM    @Msg.nodes('/DataModification/TableStructure/column') TempXML ( x );
			-- extraction de la liste des colonnes 
                DECLARE @SQLExtract NVARCHAR(MAX) = 'SELECT ';
                SELECT  @SQLExtract = @SQLExtract + 'x.value(''@' + column_name + ''', ''' + data_type
                        + CASE WHEN Charlen IS NULL THEN ''
                               ELSE '(' + Charlen + ')'
                          END + '''' + ') AS [' + column_name + '],'
                FROM    #XMLColumns;
                SET @SQLExtract = LEFT(@SQLExtract, LEN(@SQLExtract) - 1);
                SELECT  @SQLExtract = @SQLExtract + ' FROM @Msg.nodes(''/DataModification/TableData/Row'') TempXML (x)';
			-- Gnration des commandes INSERT, UPDATE, DELETE
                SELECT  *
                FROM    #XMLColumns;
                IF @SQL_ACTION = 'insert'
                    BEGIN
                        SET @SQLCmd = 'INSERT ' + @TABLE_SCHEMA + '.' + @TABLE_NAME + ' ' + @SQLExtract;
                    END;
                IF @SQL_ACTION = 'update'
                    BEGIN
                        SELECT  @ColumnList = @ColumnList + column_name + '=E.' + column_name + ','
                        FROM    #XMLColumns
                        WHERE   column_name <> @KEY_COLUMN;
                        SET @ColumnList = LEFT(@ColumnList, LEN(@ColumnList) - 1);
                        SET @SQLCmd = 'UPDATE ' + @TABLE_SCHEMA + '.' + @TABLE_NAME + ' SET ' + @ColumnList + ' FROM '
                            + @TABLE_SCHEMA + '.' + @TABLE_NAME + ' AS T JOIN (' + @SQLExtract + ') AS E ON T.'
                            + @KEY_COLUMN + '=E.' + @KEY_COLUMN;
                    END;
                IF @SQL_ACTION = 'delete'
                    BEGIN
                        SET @SQLCmd = 'DELETE ' + @TABLE_SCHEMA + '.' + @TABLE_NAME + ' FROM ' + @TABLE_SCHEMA + '.'
                            + @TABLE_NAME + ' AS T JOIN (' + @SQLExtract + ') AS E ON T.' + @KEY_COLUMN + '=E.'
                            + @KEY_COLUMN;
                    END;
			-- Excution -------------------------------------------
                EXEC sp_executesql @SQLCmd, N'@Msg xml', @Msg = @msg;
			------------ Fin dcodage et excution -----------------
                END CONVERSATION @conversation;
            END;
        ELSE
            IF ( @msgType = 'http://schemas.microsoft.com/SQL/ServiceBroker/Error' )
                OR ( @msgType = 'http://schemas.microsoft.com/SQL/ServiceBroker/EndDialog' )
                BEGIN
                    END CONVERSATION @conversation;
                END;
            ELSE
                BEGIN
                    END CONVERSATION @conversation 
	        WITH ERROR = 500 DESCRIPTION = 'Type de message non valide.';
                END;
    END;
GO

ALTER QUEUE DataSynchro_Queue   -- enclenche l'activation et dmarre la queue
WITH STATUS = ON,
ACTIVATION ( 
STATUS = ON,
PROCEDURE_NAME = Broker_Receive_DataModification, 	
MAX_QUEUE_READERS = 1,
EXECUTE AS OWNER);

--ALTER QUEUE Person_DataSynchro_Queue   -- enclenche l'activation et dmarre la queue
--WITH STATUS = ON,
--ACTIVATION ( 
--STATUS = OFF)
