USE [SBSource]
GO
/****** Object:  StoredProcedure [dbo].[CleanBrokerConversations]    Script Date: 28/08/2015 14:23:48 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROCEDURE [dbo].[CleanBrokerConversations]
AS
BEGIN
    BEGIN TRY
        -- create a memory table. I dont prefer cursors usually
        DECLARE @t TABLE( AutoID INT IDENTITY, ConversationHandle UNIQUEIDENTIFIER)
        
        -- insert the handles of all open conversations to the 
        -- memory table
        INSERT INTO 
            @t (ConversationHandle)
        SELECT 
            [conversation_handle] 
        FROM
            sys.conversation_endpoints WITH (READUNCOMMITTED)
 
        -- local variables
        DECLARE @cnt INT, @max INT, @handle UNIQUEIDENTIFIER
        SELECT @cnt = 1, @max = COUNT(*) FROM @t
        
        -- run a loop for each row in the memory table
        WHILE @cnt <= @max BEGIN
            -- read the conversation_handle
            SELECT
                @handle = ConversationHandle
            FROM @t WHERE AutoID = @cnt
            
            -- end conversation
            PRINT 'Closing conversation: ' + CAST(@handle AS VARCHAR(50))
            END CONVERSATION @handle WITH CLEANUP
            
            -- increment counter
            SELECT @cnt = @cnt + 1
        END
        
    END TRY
    BEGIN CATCH
        PRINT ERROR_MESSAGE()
    END CATCH
END
